<?php

namespace Drupal\schema\Tests;

use Drupal\simpletest\WebTestBase;

/**
 * Schema functional tests.
 *
 * @group schema
 */
class SchemaUnitTestCase extends WebTestBase {

  public static $modules = ["schema", "schema_test"];
  protected $profile = 'testing';

  public static function getInfo() {
    return [
      'name' => 'Schema functional tests',
      'description' => 'Schema functional tests',
      'group' => 'Schema',
    ];
  }

  public function setUp() {
    parent::setUp();
  }

  /*function testGetFieldTypeMap() {
    $type = $this->drupalCreateContentType();

    $field = array(
      'field_name' => 'field_schema_test',
      'type' => 'schema_test',
    );
    field_create_field($field);

    $instance = array(
      'field_name' => 'field_schema_test',
      'entity_type' => 'node',
      'bundle' => $type->type,
    );
  }*/

  public function testUnprefixTable() {
    $cases = [];

    // Test without any prefixes.
    $cases[] = [
      'options' => [],
      'cases' => [
        'a2' => 'a2',
        'a3' => 'a3',
        'b2' => 'b2',
        'b3' => 'b3',
        'test' => 'test',
        'aa_test' => 'aa_test',
        'aaa_test' => 'aaa_test',
      ],
    ];
    // Test empty default prefix.
    $cases[] = [
      'options' => [
        'prefix' => [
          'default' => '',
          'a2' => 'aa_',
          'a3' => 'aaa_',
          'b2' => 'bb_',
          'b3' => 'bbb_',
        ],
      ],
      'cases' => [
        'aa_a2' => 'a2',
        'aaa_a3' => 'a3',
        'bb_b2' => 'b2',
        'bbb_b3' => 'b3',
        'test' => 'test',
        'aa_test' => 'aa_test',
        'aaa_test' => 'aaa_test',
      ],
    ];
    // Test empty default prefix.
    $cases[] = [
      'options' => [
        'prefix' => [
          'default' => 'test_',
          'a2' => 'aa_',
          'a3' => '',
          'b2' => 'bb_',
          'b3' => '',
        ],
      ],
      'cases' => [
        'aa_a2' => 'a2',
        'test_a3' => 'a3',
        'bb_b2' => 'b2',
        'test_b3' => 'b3',
        'test' => 'test',
        'test_test' => 'test',
      ],
    ];

    foreach ($cases as $case) {
      $connection = new SchemaTestDatabaseConnection($case['options']);
      $connection->setKey($this->randomName());
      foreach ($case['cases'] as $input => $expected) {
        $result = schema_unprefix_table($input, $connection);
        $this->assertIdentical($result, $expected);
      }
    }

    // Test the default connection object parameter.
    $connection = Database::getConnection();
    foreach (['test'] as $name) {
      $input = $connection->prefixTables('{' . $name . '}');
      $result = schema_unprefix_table($input);
      $this->assertIdentical($result, $name);
    }
  }

}
